/** 
 *
 * @author		ARI Soft
 * @copyright	Copyright (c) 2011 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 *
 * The plugin is based on "ARI Quiz in Content" plugin (http://hut32.blogspot.co.uk/2009/04/how-to-display-quiz-from-ari-quiz.html).
**/

(function($) {
	$.fn.extend({
		jAriQuizInContent: function(config) {
			var self = this,
				isLoaded = false;

			config = $.extend({
				scrolling: 'auto', 
				src: '', 
				removeTitle: false, 
				uri: ''
			}, config);

			function aqResizeEl(el) {
				if (!isLoaded) {
					$(self).each(function () {
						$(this).removeClass('aq-ic-loading');
						$(el).css({ visibility: 'visible' });
					});

					isLoaded = true;
				};

				$(el).height(
					($(el).attr('_firstLoad') == '1'
						? Math.max(
								$(el.contentWindow.document.body).css('height', 'auto').css('min-height', '100%').outerHeight(true),
								$(el.contentWindow.document.body).css('height', '100%').outerHeight(true))
						: $(el.contentWindow.document.body).css('height', 'auto').outerHeight(true)) + 35
				);
				$(el.contentWindow.document.body).css('height', 'auto');

				if (config.scrolling == 'auto') {
					var innerDoc = el.contentWindow.document;
					innerDoc.body.style.display = 'block';
					innerDoc.body.style.overflow = 'auto';
				}
			};

			function aqResize() {
				$(self).each(function (i, el) {
					$(el).children('IFRAME').each(function (j, ifr) {
						aqResizeEl(ifr);
					});
				});
			};

			function aqAddImageLoadHandler(doc) {
				var imgList = doc.getElementsByTagName('img');
				if (!imgList || imgList.length < 1) 
					return;

				for (var i = 0; i < imgList.length; i++) {
					var img = imgList[i];
					$(img).load(function () {
						aqResize();
					});
				}
			};

			var createEl = function(type, attr, doc) {
				doc = doc || document;
				var newEl = doc.createElement(type);
				$.each(attr, function (key) {
					if (typeof(attr[key]) != 'undefined')
						newEl.setAttribute(key, attr[key]);
				});

				return newEl;
			};

			var loadCss = function (cssFile, doc, callback) {
				doc = doc || document;
				callback = callback || function () { };

				var linkEl = createEl('link', { 'type': 'text/css', 'rel': 'stylesheet', 'href': cssFile }, doc);
                if (navigator.userAgent.toLowerCase().indexOf("msie ") > 0 || !!navigator.userAgent.match(/Trident.*rv\:11\./)) {
					linkEl.onreadystatechange = function () { if (/loaded|complete/.test(linkEl.readyState)) callback(); };
				}
				else {
					(function () {
						try {
							if (linkEl.sheet == null || typeof (linkEl.sheet) == "undefined") {
								setTimeout(arguments.callee, 20);
								return;
							}

							linkEl.sheet.cssRule;
						}
						catch (e) {
							setTimeout(arguments.callee, 20);
							return;
						};
						callback();
					})();
				}

				(doc.getElementsByTagName('head')[0]).appendChild(linkEl);

				return linkEl;
			};

			return this.each(function(i, el) {
				$(el).children('IFRAME').each(function(j, ifr) {
					$(this).load(function(event) {
						if ($(ifr).attr('_firstLoad') == null)
							$(ifr).attr('_firstLoad', '1');
						else
							$(ifr).attr('_firstLoad', '0');

						var cw = ifr.contentWindow,
							innerDoc = cw.document;

						if (config.removeTitle) {
							$(innerDoc.body).find('FORM>H1').remove();
							$(innerDoc.body).find('DIV.ariQuizHeaderName').remove();
							$(innerDoc.body).find('H2.aq-header').remove();
						};

						//innerDoc.body.style.width = '95%';
						innerDoc.body.style.display = 'block';
						var html = innerDoc.getElementsByTagName('html')[0];
						html.style.margin = '0';
						html.style.padding = '0';

						var resizeHandler = function() {
							if (typeof(cw.ariQuizQueManager) != 'undefined' ||
								(typeof(cw.aris) != 'undefined') &&
								typeof(cw.aris.ariQuiz) != 'undefined') 
							{
								var isObjInit = (typeof(cw.ariQuizQueManager) != 'undefined'),
									aqManager = isObjInit
										? cw.ariQuizQueManager
										: cw.YAHOO.ARISoft.ariQuiz.questionManager.prototype,
									extMethods = [
									    '_drawQuestion',
									    '_drawPageQuestions',
									    '_hideLoading',
									    '_hideLoadingForElement',
									    '_showCorrectAnswer',
									    'hideCorrectAnswer',
									    '_showExplanationQuestion',
									    'hideExplanationQuestion'
									];
								
								for (var methodIdx = 0; methodIdx < extMethods.length; methodIdx++) {
									var method = extMethods[methodIdx];
									
									if (typeof(aqManager[method]) == 'undefined')
										continue ;

									(function(m) {
										var oldHandler = aqManager[m];
										aqManager[m] = function() {
											var res = oldHandler.apply(isObjInit ? aqManager : this, arguments);

											aqAddImageLoadHandler(innerDoc);
											aqResizeEl(ifr);

											return res;
										};
									})(method);
								};
								
								if (typeof(cw.aris.ariQuiz.questions) != 'undefined' && 
									typeof(cw.aris.ariQuiz.questions.util) != 'undefined' &&
									typeof(cw.aris.ariQuiz.questions.util.DDQuizCorrelation) != 'undefined' &&
									typeof(cw.aris.ariQuiz.questions.util.DDQuizCorrelation.prototype) != 'undefined' &&
									typeof(cw.aris.ariQuiz.questions.util.DDQuizCorrelation.prototype.onDragDrop) != 'undefined'
									) 
								{
									var oldOnDragDropHandler = cw.aris.ariQuiz.questions.util.DDQuizCorrelation.prototype.onDragDrop;
									
									cw.aris.ariQuiz.questions.util.DDQuizCorrelation.prototype.onDragDrop = function() {
										var res = oldOnDragDropHandler.apply(this, arguments);

										aqResizeEl(ifr);

										return res;
									};
								};

								cw.YAHOO.util.Connect.startEvent.subscribe(function() {
									if (config.scrolling == 'auto') {
										try {
											innerDoc.body.style.display = 'inline';
											innerDoc.body.style.overflow = 'none';
										}
										catch (e) { }
									}
								});
							};

							if (typeof(cw.YAHOO) != 'undefined' &&
								typeof(cw.YAHOO.ARISoft) != 'undefined' &&
								typeof(cw.YAHOO.ARISoft.DOM) != 'undefined' &&
								typeof(cw.YAHOO.ARISoft.DOM.updateHtml) != 'undefined') 
							{
								var oldUpdateHtmlHandler = cw.YAHOO.ARISoft.DOM.updateHtml;
								cw.YAHOO.ARISoft.DOM.updateHtml = function() {
									oldUpdateHtmlHandler.apply(this, arguments);

									aqResize();
								};
							}

							if (typeof(cw.YAHOO) != 'undefined' &&
								typeof(cw.YAHOO.widget) != 'undefined' &&
								typeof(cw.YAHOO.widget.DataTable) != 'undefined') 
							{
								var oldRenderHandler = cw.YAHOO.widget.DataTable.prototype.render,
									oldShowTableMessageHandler = cw.YAHOO.widget.DataTable.prototype.showTableMessage,
									oldHideTableMessageHandler = cw.YAHOO.widget.DataTable.prototype.hideTableMessage;
								cw.YAHOO.widget.DataTable.prototype.render = function() {
									oldRenderHandler.apply(this, arguments);

									aqAddImageLoadHandler(innerDoc);
									aqResize();
								};

								cw.YAHOO.widget.DataTable.prototype.showTableMessage = function() {
									oldShowTableMessageHandler.apply(this, arguments);

									aqResize();
								};

								cw.YAHOO.widget.DataTable.prototype.hideTableMessage = function() {
									oldHideTableMessageHandler.apply(this, arguments);

									aqResize();
								};
							};

							if (typeof(cw.YAHOO) != 'undefined' &&
								typeof(cw.YAHOO.ARISoft) != 'undefined' &&
								typeof(cw.YAHOO.ARISoft.Quiz) != 'undefined' &&
								typeof(cw.YAHOO.ARISoft.Quiz.formatters) != 'undefined' &&
								typeof(cw.YAHOO.ARISoft.Quiz.formatters.formatQuestionStatComplete) != 'undefined')
							{
								var oldFormatQuestionStatComplete = cw.YAHOO.ARISoft.Quiz.formatters.formatQuestionStatComplete;
								cw.YAHOO.ARISoft.Quiz.formatters.formatQuestionStatComplete = function() {
									oldFormatQuestionStatComplete.apply(this, arguments);

									aqAddImageLoadHandler(innerDoc);
									aqResize();
								};
							};

							if (typeof(cw.YAHOO) != 'undefined' &&
								typeof(cw.YAHOO.widget) != 'undefined' &&
								typeof(cw.YAHOO.widget.Paginator) != 'undefined') 
							{
								var oldPagRenderHandler = cw.YAHOO.widget.Paginator.prototype.render;
								cw.YAHOO.widget.Paginator.prototype.render = function() {
									oldPagRenderHandler.apply(this, arguments);

									aqResize();
								};
							};

							if (typeof(cw.YAHOO) != 'undefined' &&
								typeof(cw.YAHOO.ARISoft) != 'undefined' &&
								typeof(cw.YAHOO.ARISoft.widgets) != 'undefined' &&
								typeof(cw.YAHOO.ARISoft.widgets.calculator) != 'undefined') 
							{
								var protoCalc = cw.YAHOO.ARISoft.widgets.calculator.calc.prototype;
								var calcShow = protoCalc.show;
								protoCalc.show = function (el, clear) {
									calcShow.apply(this, arguments);

									$(innerDoc.body).find('.calcSelectFree').css({ position: 'relative' });
									aqResize();
									$(innerDoc.body).find('.calcSelectFree').css({ position: 'absolute' });
								};

								var calcHide = protoCalc.hide;
								protoCalc.hide = function () {
									calcHide.apply(this, arguments);
									aqResize();
								};
							};

							setTimeout(aqResize, 1);
						};

						loadCss(config.uri + 'assets/css/fix.css', innerDoc, resizeHandler);
					});

					ifr.src = config.src;
				});
			});
		}
	});
})(jQuery);